#!/usr/bin/bash
{{ ansible_managed | comment }}
# chkconfig: - 72 20
# description: svfe
# processname: svfe

# LSB compliant service control script
#
### BEGIN INIT INFO
# Provides:                     SmartVista Front-End application
# Required-Start:               $ALL
# Should-Start:
# Required-Stop:
# Should-Stop:
# Default-Start:                3 5
# Default-Stop:                 0 1 6
# Short-Description:            svfe
# Description:                  Starts and stops svfe
### END INIT INFO

########################################
#  BEGIN OF THE CONFIGURATION SECTION  #
########################################

###Rev11
#Solaris support
#Debug support
###Rev12
#Linux 7 SUDO support
###Rev13
#Debug to home folder
###Rev14
#Database wait function added
###Rev15
#Debug updated
###Rev16
#Solaris bug fixes
###Rev17
#AIX bug fixes
###Rev18
#Veritas Cluster support on exit code 100
###Rev19
#Linux 7. BUG: Username=svfe. Script can't kill process "atndnt_srv". Loop.
###Rev20
#Linux 8. Version check procedure changed due to the changed format of /etc/redhat-release.
###Rev21
#Added SVFE sentinel and pingpro support
###Rev22
#Debug function bug fixes
#Stop bugfixes
###Rev23
#AIX sentinel added
#AIX debug revised
###Rev24
#svstat debug added
#user's home folder detection bugfixes
###Rev25
#pingpro percent of alive processes added
#temp files per user added
###Rev26
#lsof version of svstat added
###Rev27
#Post actions added on 2-nd restart attempt
###Rev28
#Kill zombie processes

### PINGPRO OUTPUT FORMAT
# First part is ping time for each instance of modules in form:
#
# module name
# instance time of ping response
# instance process ID.
# Here is possible several lines for the same module name - one line for one instance.
#
# Second part of output is a summary for each module in form:
#
# module name
# number of instances alive / number of instances configured
# percent (P1) of instances alive / percent (P2) of instances to consider module is alive
# OK if P1 >= P2, NOK - otherwise
# Here is possible only one line per each module.
#
# Added new module attribute to configure value of P2 - HEALTHCHECK_THRESHOLD (618).

SV_OWNER={{ svfe_user }}
ADAPTER_NAME={{ svfe_adapter_name }}

#--------------------------------------------
#Do we need to add VIP address first?
USE_VIP=NO

VIP_ADDR=10.171.11.14
VIP_MASK=24
VIP_DEV=ens192
GW_IP=10.171.11.253

#--------------------------------------------
#Process monitoring version
#Use lsof tool to find out running SVFE processes. If not used
#svstat command would be used instead
USE_LSOF={{ svfe_use_lsof | default('TRUE') }}

# Kill zombie processes
KILL_ZOMBIE={{ svfe_kill_zombie | default('TRUE')}}
KILL_ZOMBIE_CMD=''

#Which processes should be monitored?
PROCESS_LIST={{ svfe_process_list }}
EXPECTED_PROC_NUM={{ svfe_expected_proc_num | default(svfe_def_expected_prod_num) }}

#Sentinel version
USE_SENTINEL={{ svfe_use_sentinel | default(def_svfe_use_sentinel) }}
SENTINEL_PROC_LIST="{{ svfe_sentinel_process_list | default(def_svfe_sentinel_process_list) }}"

#Exclude from check
SENTINEL_PROC_LIST_EXCL="{{ svfe_sentinel_excl_process_list }}"
SENTINEL_EXP_PROC_NUM={{ svfe_sentinel_expected_proc_num | default(def_svfe_sentinel_expected_proc_num) }}
SENTINEL_PING_PERCENT_ALIVE={{ svfe_sentinel_ping_percent_alive }}

PRC_SELECT="set heading off\nset feedback off\nSET COLSEP \",\"\ncolumn EXECUTABLE_FILE format a20\ncolumn ARGUMENT format a20\nselect EXECUTABLE_FILE,ARGUMENT from process_description;\n"
PRC_FILE_BASE=/tmp/svfe_processes
PRC_FILE_TMP_BASE=/tmp/svfe_processes_tmp
PRC_FILE_PING_BASE=/tmp/svfe_processes_ping
GET_RUN_PROC_FILE_BASE=/tmp/svfe_get_run_proc

#-------------------------------------------
#If running in Cluster environment set USE_CLUSER variable to TRUE otherwise set it to FALSE.
USE_CLUSTER={{ svfe_use_cluster }}

#-------------------------------------------
LOCK_FILE={{ svfe_lock_file | default('/tmp/svfe_lock') }}
TMP_FILE_BASE={{ svfe_tmp_file }}

#-------------------------------------------
#Shutdown Message
SHUT_MSG={{ svfe_shutdown_message }}

#-------------------------------------------
#Debug options
DEBUG_ENABLED={{ svfe_debug_enabled }}
DEBUG_FILE_NAME={{ svfe_debug_file_name }}

###Debug info to console
#0 - Disabled
#1 - Enabled
KI_VERBOSE=1

### Additional debug data to console
#0 - Disabled
#1 - Enabled
KI_QUIET=1
#-------------------------------------------
#Wait for DB startup on the same server

DB_WAIT="FALSE"      #TRUE/FALSE
DB_WAIT_SID=my_db

#Linux release file location
LINUX_RELEASE_FILE=/etc/redhat-release

#-------------------------------------------
#SVFE application options
#Do we need to execute something on the second restart attempt?
RESTART_ATTEMPT_CHK=TRUE


######################################
#  END OF THE CONFIGURATION SECTION  #
######################################

#Create lock file to exlude multiply instances of the script

create_lock_file() {

    if [ "${USE_CLUSTER}" == "FALSE" ]

        then

            #Create lock file to exlude multiply instances of the script
            if [ -e ${LOCK_FILE} ]
                    then
                            echo "Another instance of the script running... Or check for lock file: ${LOCK_FILE}"
                            exit 255
            fi

            touch ${LOCK_FILE}

        else
            echo ""
            echo "Assuming using script in the Cluster Environment"
            echo "Multiply instances of script is permited. Cluster must take care about it"
            echo ""
    fi
}

remove_lock_file() {
    if [ "${USE_CLUSTER}" == "FALSE" ]
        then
            rm -f ${LOCK_FILE}
    fi
}

SV_FOLDER=`grep "^${SV_OWNER}:" /etc/passwd | cut -d ':' -f 6`

if [ -e ${SV_FOLDER}/.profile ]
        then
                profile_file=${SV_FOLDER}/.profile
        else
                profile_file=${SV_FOLDER}/.bash_profile
fi

#Debug file location.
if [ "$USER" == "" ] || [ "$USER" == "root" ]
        then
                DEBUG_FILE=/var/log/svfe_debug.log
        else
                DEBUG_FILE=${SV_FOLDER}/svfe_debug.log
fi

#Redirect output for debugging
if [ $DEBUG_ENABLED == "TRUE" ]
    then
        DEBUG_REDIRECT=">> ${DEBUG_FILE} 2>&1"
fi

#Form process list and process number depending on configuration options
if [ "$USE_SENTINEL" == "TRUE" ]
    then
        PROCESS_LIST=$SENTINEL_PROC_LIST
        EXPECTED_PROC_NUM=$SENTINEL_EXP_PROC_NUM
        DB_LOGIN=`grep DB_LOGIN $profile_file | grep -v "^#" | cut -d "=" -f2`
fi

# Set kill zombie process cmd
if [ "$KILL_ZOMBIE" == "TRUE" ]
    then
        KILL_ZOMBIE_CMD='ps aux | grep defunct | grep svfe | grep -v grep | awk '{print $2}' | xargs kill -9'
fi


case `uname` in
    AIX)
        OS=AIX

        SHUT_LOG_CMD="/usr/bin/logger -t svfe '${SHUT_MSG}'"

        case "$USER" in
            $SV_OWNER)
                 #Make TMP_FILE variable
                TMP_FILE=${TMP_FILE_BASE}_${SV_OWNER}
                PRC_FILE=${PRC_FILE_BASE}_${SV_OWNER}
                PRC_FILE_TMP=${PRC_FILE_TMP_BASE}_${SV_OWNER}
                PRC_FILE_PING=${PRC_FILE_PING_BASE}_${SV_OWNER}
                GET_RUN_PROC_FILE=${GET_RUN_PROC_FILE_BASE}_${SV_OWNER}


                START_CMD=". $profile_file > /dev/null;${SV_FOLDER}/bin/startpro_forced all $DEBUG_REDIRECT"
                #START_CMD2=". $profile_file > /dev/null;atndnt_srv start >/dev/null 2>&1"
                STOP_CMD=". $profile_file > /dev/null;${SV_FOLDER}/bin/stop_SV $DEBUG_REDIRECT"
                #STOP_CMD2=". $profile_file > /dev/null;atndnt_srv stop $DEBUG_REDIRECT"
                STOP_CMD3=". $profile_file > /dev/null;$SV_FOLDER/bin/sv_cleanup $DEBUG_REDIRECT"

                STAT_CMD=". $profile_file > /dev/null;${SV_FOLDER}/bin/svstat | grep -v 'NOT RUNNING' | egrep -e '(${PROCESS_LIST})' | grep RUNNING | wc -l > $TMP_FILE 2>/dev/null"
                SQL_PRC_CMD=". $profile_file;printf '${PRC_SELECT}' | sqlplus -silent $DB_LOGIN | grep -v -e '^$' > $PRC_FILE"
                GET_RUN_PROC=". $profile_file > /dev/null 2>&1; $SV_FOLDER/bin/svstat | grep -v 'NOT RUNNING' | grep 'RUNNING' | egrep -v -e '(${SENTINEL_PROC_LIST_EXCL})' | cut -f2 | sed -e 's/ \+//g' | tr '\n' ' ' | sed -e 's/[[:blank:]]\{1,\}/ /g'"
                STAT_CMD_PING=". $profile_file > /dev/null 2>&1; pingpro PLACE_HOLDER"
                STAT_CMD_SVSTAT=". $profile_file > /dev/null 2>&1; $SV_FOLDER/bin/svstat"
                PCMD=". $profile_file > /dev/null 2>&1;svstat | grep -v \"NOT RUNNING\" | grep RUNNING | sed -e 's/([0-9]*)//g' | sed -e 's/\t//g' | cut -d \"G\" -f 2 | tr -d '\n' | sed -e 's/^ //'"
            ;;

            *)
                #Make TMP_FILE variable
                TMP_FILE=${TMP_FILE_BASE}_root
                PRC_FILE=${PRC_FILE_BASE}_root
                PRC_FILE_TMP=${PRC_FILE_TMP_BASE}_root
                PRC_FILE_PING=${PRC_FILE_PING_BASE}_root
                GET_RUN_PROC_FILE=${GET_RUN_PROC_FILE_BASE}_root

                START_CMD="su - $SV_OWNER -c \". $profile_file > /dev/null;${SV_FOLDER}/bin/startpro_forced all\" $DEBUG_REDIRECT"

                STOP_CMD="su - $SV_OWNER -c \". $profile_file > /dev/null;${SV_FOLDER}/bin/stop_SV\" $DEBUG_REDIRECT"
                STOP_CMD3="su - $SV_OWNER -c \". $profile_file > /dev/null;$SV_FOLDER/bin/sv_cleanup \" $DEBUG_REDIRECT"

                STAT_CMD="su - $SV_OWNER -c \". $profile_file > /dev/null;${SV_FOLDER}/bin/svstat | grep -v 'NOT RUNNING' | egrep -e '(${PROCESS_LIST})' | grep RUNNING | wc -l > $TMP_FILE 2>/dev/null\""

                SQL_PRC_CMD="su - $SV_OWNER -c \". $profile_file;printf '${PRC_SELECT}' | sqlplus -silent $DB_LOGIN | grep -v -e '^$' > $PRC_FILE\""
                GET_RUN_PROC="su - $SV_OWNER -c \". $profile_file > /dev/null 2>&1; $SV_FOLDER/bin/svstat | grep -v 'NOT RUNNING' | grep 'RUNNING' | egrep -v -e'(${SENTINEL_PROC_LIST_EXCL})' | cut -f2 | sed -e 's/ \+//g' | tr '\n' ' ' | sed -e 's/[[:blank:]]\{1,\}/ /g'\""
                STAT_CMD_PING="su - $SV_OWNER -c \". $profile_file > /dev/null 2>&1; pingpro PLACE_HOLDER\""
                STAT_CMD_SVSTAT="su - $SV_OWNER -c \". $profile_file > /dev/null 2>&1; $SV_FOLDER/bin/svstat\""
                PCMD="su - $SV_OWNER -c \". $profile_file > /dev/null;svstat | grep -v 'NOT RUNNING' | grep RUNNING | sed -e 's/([0-9]*)//g' | sed -e 's/\t//g' | cut -d \"G\" -f 2 | tr -d '\n' | sed -e 's/^ //'\""



            ;;
        esac
    ;;

    Linux)
        OS=Linux
        #LINUX_RELEASE=`cat /etc/redhat-release | awk '{print $7}' | cut -d. -f1`
        if [ -d $LINUX_RELEASE_FILE ]
            then
                LINUX_RELEASE=`cat $LINUX_RELEASE_FILE | grep -oP "release \K[[:digit:]](?=\.[[:digit:]])"`
            else
                LINUX_RELEASE=0
        fi
        SHUT_LOG_CMD="/usr/bin/logger -t svfe '${SHUT_MSG}'"

        case "$USER" in

            root)
                #Make TMP_FILE variable
                TMP_FILE=${TMP_FILE_BASE}_root
                PRC_FILE=${PRC_FILE_BASE}_root
                PRC_FILE_TMP=${PRC_FILE_TMP_BASE}_root
                PRC_FILE_PING=${PRC_FILE_PING_BASE}_root
                GET_RUN_PROC_FILE=${GET_RUN_PROC_FILE_BASE}_root

                START_CMD="su - $SV_OWNER -c \". $profile_file > /dev/null; $SV_FOLDER/bin/startpro_forced all\" $DEBUG_REDIRECT"
                STOP_CMD="su - $SV_OWNER -c \". $profile_file > /dev/null; $SV_FOLDER/bin/stop_SV\" $DEBUG_REDIRECT"
                STOP_CMD3="su - $SV_OWNER -c \". $profile_file > /dev/null; $SV_FOLDER/bin/sv_cleanup\" $DEBUG_REDIRECT"

                STAT_CMD="su - $SV_OWNER -c \". $profile_file > /dev/null 2>&1; $SV_FOLDER/bin/svstat | grep -v 'NOT RUNNING' | egrep -e '(${PROCESS_LIST})' | grep RUNNING | wc -l > $TMP_FILE 2>/dev/null\""
                STAT_CMD_SVSTAT="su - $SV_OWNER -c \". $profile_file > /dev/null 2>&1; $SV_FOLDER/bin/svstat\""
                STAT_CMD_LSOF="lsof -S 1 -Fpn `find $SV_FOLDER/bin -type f` 2>/dev/null | wc -l"
                STAT_CMD_PING="su - $SV_OWNER -c \". $profile_file > /dev/null 2>&1; pingpro PLACE_HOLDER\""

                SQL_PRC_CMD="su - ${SV_OWNER} \"-c . $profile_file;printf '${PRC_SELECT}' | sqlplus -silent $DB_LOGIN | grep -v -e '^$' > $PRC_FILE\""
                GET_RUN_PROC="su - $SV_OWNER -c \". $profile_file > /dev/null 2>&1; $SV_FOLDER/bin/svstat | grep -v 'NOT RUNNING' | grep 'RUNNING' | egrep -v -e '(${SENTINEL_PROC_LIST_EXCL})' | cut -f2 | sed -e 's/ \+//g' | tr '\r\n' ' '\""

                PCMD="su - ${SV_OWNER} \"-c svstat | grep -v 'NOT RUNNING' | grep RUNNING | sed -e 's/([0-9]*)//g' | sed -e 's/\t//g' | cut -d \"G\" -f 2 | tr -d '\n' | sed -e 's/^ //'\""

                ADD_VIP="/sbin/ip addr add ${VIP_ADDR}/${VIP_MASK} dev $VIP_DEV"
                DEL_VIP="/sbin/ip addr del ${VIP_ADDR}/${VIP_MASK} dev $VIP_DEV"
                PING_GW="/bin/ping -c 2 -I $VIP_ADDR $GW_IP"
                PING_ARP="/sbin/arping -U -c 2 -s $VIP_ADDR -I $VIP_DEV $GW_IP"

            ;;

            $SV_OWNER)

                #Make TMP_FILE variable
                TMP_FILE=${TMP_FILE_BASE}_${SV_OWNER}
                PRC_FILE=${PRC_FILE_BASE}_${SV_OWNER}
                PRC_FILE_TMP=${PRC_FILE_TMP_BASE}_${SV_OWNER}
                PRC_FILE_PING=${PRC_FILE_PING_BASE}_${SV_OWNER}
                GET_RUN_PROC_FILE=${GET_RUN_PROC_FILE_BASE}_${SV_OWNER}

                START_CMD=". $profile_file > /dev/null; $SV_FOLDER/bin/startpro_forced all $DEBUG_REDIRECT"
                POST_START_CMD1=". $profile_file > /dev/null; $SV_FOLDER/bin/ch_debug_lvl 4 n; $SV_FOLDER/bin/ch_debug_lvl 4 epayint; $SV_FOLDER/bin/ch_debug_lvl 4 stdauth  $DEBUG_REDIRECT"
                STOP_CMD=". $profile_file > /dev/null; $SV_FOLDER/bin/stop_SV $DEBUG_REDIRECT"
                STOP_CMD3=". $profile_file > /dev/null; $SV_FOLDER/bin/sv_cleanup $DEBUG_REDIRECT"

                STAT_CMD=". $profile_file > /dev/null; $SV_FOLDER/bin/svstat | grep -v 'NOT RUNNING' | egrep -e '(${PROCESS_LIST})' | grep RUNNING | wc -l > $TMP_FILE 2>/dev/null"
                STAT_CMD_SVSTAT=". $profile_file > /dev/null 2>&1; ${SV_FOLDER}/bin/svstat"
                STAT_CMD_LSOF="lsof -S 1 -Fpn `find $SV_FOLDER/bin -type f` 2>/dev/null | wc -l"
                STAT_CMD_PING=". $profile_file > /dev/null 2>&1; pingpro PLACE_HOLDER"
                SQL_PRC_CMD=". $profile_file;printf '${PRC_SELECT}' | sqlplus -silent $DB_LOGIN | grep -v -e '^$' > $PRC_FILE"
                GET_RUN_PROC=". $profile_file > /dev/null 2>&1; $SV_FOLDER/bin/svstat | grep -v 'NOT RUNNING' | grep 'RUNNING' | egrep -v -e '(${SENTINEL_PROC_LIST_EXCL})' | cut -f2 | sed -e 's/ \+//g' | tr '\r\n' ' '"

                PCMD="svstat | grep -v \"NOT RUNNING\" | grep RUNNING | sed -e 's/([0-9]*)//g' | sed -e 's/\t//g' | cut -d \"G\" -f 2 | tr -d '\n' | sed -e 's/^ //'"

                ADD_VIP="/bin/sudo /sbin/ip addr add ${VIP_ADDR}/${VIP_MASK} dev $VIP_DEV"
                DEL_VIP="/bin/sudo /sbin/ip addr del ${VIP_ADDR}/${VIP_MASK} dev $VIP_DEV"
                PING_GW="/bin/ping -c 2 -I $VIP_ADDR $GW_IP"
                PING_ARP="/sbin/arping -U -c 2 -s $VIP_ADDR -I $VIP_DEV $GW_IP"

            ;;

            *)

                #Make TMP_FILE variable
                TMP_FILE=${TMP_FILE_BASE}_root
                PRC_FILE=${PRC_FILE_BASE}_root
                PRC_FILE_TMP=${PRC_FILE_TMP_BASE}_root
                PRC_FILE_PING=${PRC_FILE_PING_BASE}_root
                GET_RUN_PROC_FILE=${GET_RUN_PROC_FILE_BASE}_root

                START_CMD="su - $SV_OWNER -c \". $profile_file > /dev/null; $SV_FOLDER/bin/startpro_forced all\" $DEBUG_REDIRECT"
                #START_CMD2="su - $SV_OWNER -c \"atndnt_srv start\"  $DEBUG_REDIRECT"
                STOP_CMD="su - $SV_OWNER -c \". $profile_file > /dev/null; $SV_FOLDER/bin/stop_SV\" $DEBUG_REDIRECT"
                #STOP_CMD2="su - $SV_OWNER -c \". $profile_file > /dev/null; atndnt_srv stop\"  $DEBUG_REDIRECT"
                STOP_CMD3="su - $SV_OWNER -c \". $profile_file > /dev/null; $SV_FOLDER/bin/sv_cleanup\" $DEBUG_REDIRECT"

                STAT_CMD="su - $SV_OWNER -c \". $profile_file > /dev/null 2>&1; $SV_FOLDER/bin/svstat | grep -v 'NOT RUNNING' | egrep -e '(${PROCESS_LIST})' | grep RUNNING | wc -l > $TMP_FILE 2>/dev/null\""
                STAT_CMD_SVSTAT="su - $SV_OWNER -c \". $profile_file > /dev/null 2>&1; $SV_FOLDER/bin/svstat\""

                #PCMD="pgrep -u ${SV_OWNER}"
                PCMD="grep -vxf <(pgrep ${ADAPTER_NAME}) <(pgrep -u ${SV_OWNER})"

                ADD_VIP="/sbin/ip addr add ${VIP_ADDR}/${VIP_MASK} dev $VIP_DEV"
                DEL_VIP="/sbin/ip addr del ${VIP_ADDR}/${VIP_MASK} dev $VIP_DEV"
                PING_GW="/bin/ping -c 2 -I $VIP_ADDR $GW_IP"
                PING_ARP="/sbin/arping -U -c 2 -s $VIP_ADDR -I $VIP_DEV $GW_IP"

            ;;
        esac

    ;;

    SunOS)
        OS=SunOS
        #CURRENT_SHELL=`basename $SHELL`
        SHUT_LOG_CMD="/usr/bin/logger -t svfe '${SHUT_MSG}'"
        #PCMD="ps -f -u $SV_OWNER | grep -v $ADAPTER_NAME | grep -v sshd | grep -v $CURRENT_SHELL | /usr/bin/awk '{print \$2}' | tail +2"
        PCMD="ps -f -u $SV_OWNER | grep -v $ADAPTER_NAME | /usr/bin/awk '{print \$2}' | tail +2"

        case "$LOGNAME" in
        root)

            #Make TMP_FILE variable
            TMP_FILE=${TMP_FILE_BASE}_root
            PRC_FILE=${PRC_FILE_BASE}_root
            PRC_FILE_TMP=${PRC_FILE_TMP_BASE}_root
            PRC_FILE_PING=${PRC_FILE_PING_BASE}_root
            GET_RUN_PROC_FILE=${GET_RUN_PROC_FILE_BASE}_root

            START_CMD="su - $SV_OWNER -c \". $profile_file > /dev/null; $SV_FOLDER/bin/startpro_forced all\" $DEBUG_REDIRECT"
            #START_CMD2="su - $SV_OWNER -c \"atndnt_srv start\"  >/dev/null 2>&1"
            STOP_CMD="su - $SV_OWNER -c \". $profile_file > /dev/null; $SV_FOLDER/bin/stop_SV\" $DEBUG_REDIRECT"
            #STOP_CMD2="su - $SV_OWNER -c \". $profile_file > /dev/null; atndnt_srv stop\"  $DEBUG_REDIRECT"
            STOP_CMD3="su - $SV_OWNER -c \". $profile_file > /dev/null; $SV_FOLDER/bin/sv_cleanup\" $DEBUG_REDIRECT"
            STAT_CMD="su - $SV_OWNER -c \". $profile_file > /dev/null 2>&1; $SV_FOLDER/bin/svstat | grep -v 'NOT RUNNING' | egrep -e '(${PROCESS_LIST})' | grep RUNNING | wc -l > $TMP_FILE 2>/dev/null\""
            STAT_CMD_SVSTAT="su - $SV_OWNER -c \". $profile_file > /dev/null 2>&1; $SV_FOLDER/bin/svstat\""


        ;;
        $SV_OWNER)

            #Make TMP_FILE variable
            TMP_FILE=${TMP_FILE_BASE}_${SV_OWNER}
            PRC_FILE=${PRC_FILE_BASE}_${SV_OWNER}
            PRC_FILE_TMP=${PRC_FILE_TMP_BASE}_${SV_OWNER}
            PRC_FILE_PING=${PRC_FILE_PING_BASE}_${SV_OWNER}
            GET_RUN_PROC_FILE=${GET_RUN_PROC_FILE_BASE}_${SV_OWNER}

            START_CMD=". $profile_file > /dev/null; $SV_FOLDER/bin/startpro_forced all $DEBUG_REDIRECT"
            #START_CMD2="atndnt_srv start >/dev/null 2>&1"
            STOP_CMD=". $profile_file > /dev/null; $SV_FOLDER/bin/stop_SV $DEBUG_REDIRECT"
            #STOP_CMD2=". $profile_file > /dev/null; atndnt_srv stop $DEBUG_REDIRECT"
            STOP_CMD3=". $profile_file > /dev/null; $SV_FOLDER/bin/sv_cleanup $DEBUG_REDIRECT"
            STAT_CMD=". $profile_file > /dev/null 2>&1; $SV_FOLDER/bin/svstat | grep -v 'NOT RUNNING' | egrep -e '(${PROCESS_LIST})' | grep RUNNING | wc -l > $TMP_FILE 2>/dev/null"
            STAT_CMD_SVSTAT=". $profile_file > /dev/null 2>&1; ${SV_FOLDER}/bin/svstat"

        ;;
        *)

            #Make TMP_FILE variable
            TMP_FILE=${TMP_FILE_BASE}_root
            PRC_FILE=${PRC_FILE_BASE}_root
            PRC_FILE_TMP=${PRC_FILE_TMP_BASE}_root
            PRC_FILE_PING=${PRC_FILE_PING_BASE}_root
            GET_RUN_PROC_FILE=${GET_RUN_PROC_FILE_BASE}_root

            START_CMD="su - $SV_OWNER -c \". $profile_file > /dev/null; $SV_FOLDER/bin/startpro_forced all\" $DEBUG_REDIRECT"
            #START_CMD2="su - $SV_OWNER -c \"atndnt_srv start\"  >/dev/null 2>&1"
            STOP_CMD="su - $SV_OWNER -c \". $profile_file > /dev/null; $SV_FOLDER/bin/stop_SV\" $DEBUG_REDIRECT"
            #STOP_CMD2="su - $SV_OWNER -c \". $profile_file > /dev/null; atndnt_srv stop\"  $DEBUG_REDIRECT"
            STOP_CMD3="su - $SV_OWNER -c \". $profile_file > /dev/null; $SV_FOLDER/bin/sv_cleanup\" $DEBUG_REDIRECT"
            STAT_CMD="su - $SV_OWNER -c \". $profile_file > /dev/null 2>&1; $SV_FOLDER/bin/svstat | grep -v 'NOT RUNNING' | egrep -e '(${PROCESS_LIST})' | grep RUNNING | wc -l > $TMP_FILE 2>/dev/null\""
            STAT_CMD_SVSTAT="su - $SV_OWNER -c \". $profile_file > /dev/null 2>&1; $SV_FOLDER/bin/svstat\""

        ;;
    esac



    ;;

    *)
        echo "Cant Determine OS"
    ;;
esac

#if [ $UID -ne 0 ]; then
#        RETVAL=255
#        echo "This script must be executed by root."
#    exit $RETVAL
#fi

RETVAL=0
BOOTUP=color
RES_COL=60
MOVE_TO_COL="echo -en \\033[${RES_COL}G"
SETCOLOR_SUCCESS="echo -en \\033[1;32m"
SETCOLOR_FAILURE="echo -en \\033[1;31m"
SETCOLOR_NORMAL="echo -en \\033[0;39m"

echo_success() {
        [ "$BOOTUP" = "color" ] && $MOVE_TO_COL
        echo -n "["
        [ "$BOOTUP" = "color" ] && $SETCOLOR_SUCCESS
        echo -n $"  OK  "
        [ "$BOOTUP" = "color" ] && $SETCOLOR_NORMAL
        echo -n "]"
        echo -ne "\r"
        return 0
}

echo_failure() {
        [ "$BOOTUP" = "color" ] && $MOVE_TO_COL
        echo -n "["
        [ "$BOOTUP" = "color" ] && $SETCOLOR_FAILURE
        echo -n $"FAILED"
        [ "$BOOTUP" = "color" ] && $SETCOLOR_NORMAL
        echo -n "]"
        echo -ne "\r"
        return 1
}

function debug_print {
    if [ "$DEBUG_ENABLED" == "TRUE" ]
        then
            if [ -n "$1" ]
                then
                    IN="$1"
                else
                    read IN
            fi
            echo `date` ':' "$IN" >> $DEBUG_FILE
    fi
}

log()
{
    echo `date '+%F %H:%M:%S'` `hostname` "$LOGNAME: $*" >> "$DEBUG_FILE"
}

msg()
{
    if [ $DEBUG_ENABLED == "TRUE" ]
        then
            log "$*"
            [ $KI_VERBOSE -ne 0 -a $KI_QUIET -eq 0 ] && echo "$*"
            [ $KI_VERBOSE -ne 0 -a $KI_QUIET -ne 0 ] && echo `date '+%F %H:%M:%S'` `basename $0`": $*"
    fi
}

wrap_exec()
{
    if [ $DEBUG_ENABLED == "TRUE" ]
        then
            log "--- Executing $* ---"
                if [ $KI_VERBOSE -ne 0 ]
                    then
                        $* | tee -a "$DEBUG_FILE"
                    else
                        $* >> "$DEBUG_FILE"
                fi
            log "--- Exit of $* ---"
    fi
}

function db_wait {

    if [ "$DB_WAIT" == "TRUE" ]
        then

            echo "Waiting for a database startup"

            DB_WAIT_NAME=ora_smon_${DB_WAIT_SID}
            DB_WAIT_GET=`ps -ef | grep -v grep | grep $DB_WAIT_NAME | awk '{print \$8}'`

            while [ "$DB_WAIT_GET" != "$DB_WAIT_NAME" ]
                do

                    DB_WAIT_GET=`ps -ef | grep -v grep | grep $DB_WAIT_NAME | awk '{print \$8}'`
                    debug_print "ps command output: $DB_WAIT_GET"
                    debug_print "Waiting for $DB_WAIT_SID startup..."
                    sleep 5
                done

        echo "The database has been started"
        debug_print "The database has been started"
        sleep 5


    fi


}

function restart_attempt {

        if [ "$RESTART_ATTEMPT_CHK" == "TRUE" ]
                then
                        msg "Restart attempt check requsted"
                        CLUSTER_LOG_FILE=/var/VRTSvcs/log/engine_A.log
                        LOCAL_HOSTNAME=`hostname`
                        RESUURCE_NAME=svfe_app
                        LOG_TIME_INTERVAL=5

                        ### Log file time format:
                        ### 2021/07/13 14:46:40

                        CURR_DATE_TS=`date +%s`
                        #CURR_DATE_TS=1727953482


                        while read line

                                do
                                        msg $line
                                        #check for approprite time
                                        LINE_LOG_DATE=`echo $line | egrep -e "\($LOCAL_HOSTNAME\).+\($RESUURCE_NAME\).+attempt number" | awk -F " VCS ERROR " '{print $1}'`
                                        LINE_TIME_STAMP=`date -d "$LINE_LOG_DATE" +%s`
                                        TMP=`echo "$CURR_DATE_TS - $LINE_TIME_STAMP" | bc`

                                        if [ $TMP -le $LOG_TIME_INTERVAL ]
                                                then
                                                ### check for attempt number
                                                ATTEMPT_NUMBER=`echo $line | sed -n 's/.*attempt number \([0-9]*\).*/\1/p'`
                                                if [ $ATTEMPT_NUMBER -ge 2 ]
                                                        then
                                                                msg "ATTEMPT_NUMBER: $ATTEMPT_NUMBER"
                                                                msg "DATE: $LINE_LOG_DATE"
                                                                msg "TIME DIFFERENCE: $TMP sec"
                                                                msg "Setting RESTART_ATTEMPT_ACTION to TRUE"
                                                                RESTART_ATTEMPT_ACTION=TRUE

                                                fi
                                        fi
                        done < <(egrep -e "\($LOCAL_HOSTNAME\).+\($RESUURCE_NAME\).+attempt number" $CLUSTER_LOG_FILE)


        fi


}

function post_start {


        msg "I am in post_start function"
        msg "RESTART_ATTEMPT_CHK: $RESTART_ATTEMPT_CHK"
        msg "RESTART_ATTEMPT_ACTION: $RESTART_ATTEMPT_ACTION"


        if [ "$RESTART_ATTEMPT_CHK" == "TRUE" ] && [ "$RESTART_ATTEMPT_ACTION" == "TRUE" ]
                then
                        msg "Executing POST start action $POST_START_CMD1"
                        eval $POST_START_CMD1
        fi


}

start() {

    db_wait
    restart_attempt

    START_STATUS=""

    #echo -n $"Starting SmartVista Wallet processes: "
        #su - $SV_OWNER -c ". .bash_profile; echo \"fjvFcj223qcd\" | $SV_FOLDER/bin/wallet start"  >/dev/null 2>&1
        #RETVAL=$?
        #[ $RETVAL -eq 0 ] && echo_success && START_STATUS=${START_STATUS}success
        #[ $RETVAL -ne 0 ] && echo_failure && START_STATUS=${START_STATUS}fail
    #sleep 2
        #echo

    msg "Executing command:\n $START_CMD"
        echo -n $"Starting SmartVista FrontEnd processes: "
    debug_print "Executing command:\n $START_CMD"
    eval $START_CMD
        RETVAL=$?
        [ $RETVAL -eq 0 ] && echo_success && START_STATUS=${START_STATUS}success
        [ $RETVAL -ne 0 ] && echo_failure && START_STATUS=${START_STATUS}fail
        echo


    post_start


    echo "$START_STATUS" | grep fail >/dev/null
    if [ $? -eq 0 ]
        then
            RETVAL=255
        else
            RETVAL=0
    fi
        return $RETVAL
}

function stop {

    msg "Executing command:\n $STOP_CMD"
        echo -n $"Stopping SmartVista FrontEnd processes:  "
    debug_print "Executing command:\n $STOP_CMD"

    eval $STOP_CMD
    RETVAL=$?
    [ $RETVAL -eq 0 ] && echo_success
    [ $RETVAL -ne 0 ] && echo_failure
    echo
    echo -n $"Check for Zombie processes"
    eval ${KILL_ZOMBIE_CMD}

    echo -n $"Cleaning up:  "

    eval $STOP_CMD3 > /dev/null
        [ $RETVAL -eq 0 ] && echo_success
        [ $RETVAL -ne 0 ] && echo_failure
        echo
        return $RETVAL

}

status() {

#### Solaris CLuster
#Keep in mind solaris cluster accepts exit codes from 1 to 99 as degrated and 100 as fatal
#use exit code 100 or higher for Solaris Cluster
#use exit code 100 for Veritas Cluster

    log "Trying to check if SVFE processes are alive: "
    [ $KI_VERBOSE -eq 0 ] && echo -n $"Trying to check if SVFE processes are alive: "

    if [ "$USE_SENTINEL" == "TRUE" ]
        then
            msg "Using SENTINEL configuration"
            rm $PRC_FILE 2>/dev/null
            rm $PRC_FILE_TMP 2>/dev/null
            rm $PRC_FILE_PING 2>/dev/null
            rm $GET_RUN_PROC_FILE 2>/dev/null
            PING_STAT="OK"

            msg "Getting process list from the DB"
            msg "PROFILE: $profile_file"
            msg "DB_LOGIN: $DB_LOGIN"
            wrap_exec "eval $SQL_PRC_CMD"
            wrap_exec "cat $PRC_FILE"
            grep ORA- $PRC_FILE >/dev/null 2>&1
            if [ $? -eq 0 ]
                then
                    msg "Failed to get the process list from the DB"
                    PING_STAT="FAIL"

                else
                    msg "Processing process list"
                    cat $PRC_FILE | sed -e 's/[[:blank:]]//g' > $PRC_FILE_TMP
                    mv $PRC_FILE_TMP $PRC_FILE
                    PROCESS_TO_PING=""

                    eval $GET_RUN_PROC > $GET_RUN_PROC_FILE

                    NUM_PING_PROCESSES=`wc -w $GET_RUN_PROC_FILE | awk '{print $1}'`

                    if [ $NUM_PING_PROCESSES -gt 1 ]
                        then

                            wrap_exec "cat $GET_RUN_PROC_FILE"

                            for process_name in `cat $GET_RUN_PROC_FILE`
                                do
                                    process_alias=`grep "^$process_name," $PRC_FILE | cut -d "," -f2`
                                    PROCESS_TO_PING="${PROCESS_TO_PING} $process_alias"
                                done

                            msg "PROCESS_TO_PING variable: $PROCESS_TO_PING"

                            echo $PROCESS_TO_PING > $PRC_FILE_PING

                            wrap_exec "cat $PRC_FILE_PING"

                            msg "Pinging SVFE processes..."
                            STAT_CMD_PING=`echo $STAT_CMD_PING | sed -e 's/PLACE_HOLDER/\`cat \$PRC_FILE_PING\` | grep '%100' 2>\/dev\/null/'`
                            msg "STAT_CMD_PING: $STAT_CMD_PING"
                            PING_RESULT=`eval $STAT_CMD_PING | grep -v -e '^$' `
                            msg "$PING_RESULT"
                            while IFS= read -r ping_line
                                do
                                    if [ "${ping_line}x" == "x" ]
                                        then
                                            continue
                                    fi
                                    result_line=$(echo $ping_line | awk '{print $3}' | cut -d '%' -f 1)
                                    if [ $result_line -lt $SENTINEL_PING_PERCENT_ALIVE ]
                                        then
                                            FAILED_PROCESSES="$FAILED_PROCESSES $(echo $ping_line | awk '{print $1}')"
                                            msg "Percent of alive instances for $(echo $ping_line | awk '{print $1}') is less than $SENTINEL_PING_PERCENT_ALIVE %"
                                            PING_STAT="FAIL"
                                    fi
                                done<<< "$PING_RESULT"
                            msg "Ping has been completed with result: $PING_STAT"
                            [ "$PING_STAT" == "FAIL" ] && msg "Fail to PING processes: $FAILED_PROCESSES"
                        else
                            msg "No processes found to send PING to. Setting PING_STAT to FAIL"
                            PING_STAT="FAIL"
                    fi
            fi
        else
            msg "Using SVSTAT configuration"
            PING_STAT="OK"

    fi


    PRC_LIST_MSG="List of processes to be run, Expected number"
    if [ "$USE_SENTINEL" == "TRUE" ]
        then
            msg "$PRC_LIST_MSG: $SENTINEL_PROC_LIST, $SENTINEL_EXP_PROC_NUM"
        else
            msg "$PRC_LIST_MSG: $PROCESS_LIST, $EXPECTED_PROC_NUM"
    fi


        if [ "$USE_LSOF" == "TRUE" ]
                then
                        msg "Using LSOF version"
                        if [ -d $SV_FOLDER/bin ]
                                then
                                        svfe_app_status=`eval $STAT_CMD_LSOF`
                                else
                                        svfe_app_status=0
                        fi
                else
                        wrap_exec "eval $STAT_CMD_SVSTAT > $TMP_FILE"
                        svfe_app_status=`eval "cat $TMP_FILE | grep -v 'NOT RUNNING' | egrep -e '(${PROCESS_LIST})' | grep RUNNING | wc -l"`
        fi

    msg "Number of processes: $svfe_app_status"

    if [ "$USE_LSOF" == "TRUE" ]
            then
                    if [ "${svfe_app_status}" -gt 0 ]
                            then
                                    msg "LSOF version: Ignoring number of processes at least 1 should run"
                                    SVFE_STAT="OK"
                            else
                                    SVFE_STAT="FAIL"
                    fi
            else
                    if [ ${svfe_app_status}x == ${EXPECTED_PROC_NUM}x ]
                            then
                                    SVFE_STAT="OK"
                            else
                                    SVFE_STAT="FAIL"
                                    msg "Number of SVFE processes doesnt match expected of: $EXPECTED_PROC_NUM"
                                    wrap_exec "cat $TMP_FILE"
                    fi
    fi

    msg "PING_STAT: $PING_STAT, SVFE_STAT: $SVFE_STAT"
    if [ "$PING_STAT" == "OK" ] && [ "$SVFE_STAT" == "OK" ]
            then
                    RETVAL=0
            else
                    RETVAL=100

    fi

        [ $KI_VERBOSE -eq 0 -a $RETVAL -eq 0 ] && echo_success
        [ $KI_VERBOSE -eq 0 -a $RETVAL -ne 0 ] && echo_failure
    echo

        return $RETVAL
}


restart(){
        stop
        start
}

function add_vip_addr {

        if [ $USE_VIP == YES ]
                then

            if [ $LINUX_RELEASE -eq 7 ] && [ "$USER" == "$SV_OWNER" ]
                then
                    echo "Please add the following to the /etc/sudoers file:
$SV_OWNER        ALL=(ALL)       NOPASSWD: /sbin/ip addr add *
$SV_OWNER        ALL=(ALL)       NOPASSWD: /sbin/ip addr del *
"
            fi

                        echo "Adding Virtual IP address"
                        eval $ADD_VIP
                        sleep 2
                        echo "Pinging Default Gateway"
                        eval $PING_GW
                        sleep 2
                        echo "Sending gratious ARP"
                        eval $PING_ARP
                else
                        echo "Adding Virtual IP address is not enabled"
        fi
}

function remove_vip_addr {
        if [ $USE_VIP == YES ]
                then
                        echo "Deleting Virtual IP address"
                        eval $DEL_VIP
                else
                        echo "Adding Virtual IP address is not enabled"
        fi
}

function print_commands {

    echo "PCMD: $PCMD"
}


case "$1" in
    start)
        msg "Executing script with option START..."
        if [ "$OS" == "Linux" ]
            then
                if [ $LINUX_RELEASE -lt 7 -a "$USER" != "$SV_OWNER" ]
                    then
                        touch /var/lock/subsys/svfe
                fi
        fi
        create_lock_file
        add_vip_addr
        start
        remove_lock_file
    ;;
    stop)
        msg "Executing script with option STOP..."
        create_lock_file
        stop
        remove_vip_addr
        eval $SHUT_LOG_CMD
        if [ "$OS" == "Linux" ]
            then
                if [ $LINUX_RELEASE -lt 7 -a "$USER" != "$SV_OWNER" ]
                    then
                        rm -f /var/lock/subsys/svfe
                fi
        fi
        remove_lock_file
    ;;
    restart)
        msg "Executing script with option RESTART..."
        create_lock_file
        restart
        remove_lock_file
    ;;
    status)
        msg "Executing script with option STATUS..."
        status
    ;;
    add_vip)
        add_vip_addr
    ;;
    del_vip)
        remove_vip_addr
    ;;
    print)
        print_commands
    ;;
    *)
        echo $"Usage: $0 {start|stop|restart|status|add_vip|del_vip|print}"
        RETVAL=255
    ;;
esac

msg "Exiting script with Exicode Code: $RETVAL"
echo -n $"Script was:"
[ $RETVAL -eq 0 ] && echo_success
[ $RETVAL -ne 0 ] && echo_failure
echo

exit $RETVAL
